Index: /trunk/tools/variables_values.dat
===================================================================
--- /trunk/tools/variables_values.dat	(revision 616)
+++ /trunk/tools/variables_values.dat	(revision 617)
@@ -54,4 +54,6 @@
 pbase, clp, cloud_base_pressure, -0.3, 0.3, cloud|base|pressure, Pa, Reds
 LPBASE, clp, cloud_base_pressure, -0.3, 0.3, cloud|base|pressure, Pa, Reds
+CLW, clw, total_cloud_properties, 0., 3., total|column-integrated|water|vapor|and|cloud|variables, 1, Purples
+clw, clw, total_cloud_properties, 0., 3., total|column-integrated|water|vapor|and|cloud|variables, 1, Purples
 cpt, cpt, convective_point, 0., 1., convective|point, 1, seismic
 ptconv, cpt, convective_point, 0., 1., convective|point, 1, seismic
@@ -140,4 +142,8 @@
 g, g, grauepl_mixing_ratio, 0., 0.0003, graupel|mixing|ratio, kgkg-1, Purples
 QGRAUPEL, g, grauepl_mixing_ratio, 0., 0.0003, graupel|mixing|ratio, kgkg-1, Purples
+GLW, glw, downward_longwave_radiation_at_ground, 100., 500., downward|longwave|radiation|flux|at|the|ground|(downward|is|positive), Wm-2, Reds
+glw, glw, downward_longwave_radiation_at_ground, 100., 500., downward|longwave|radiation|flux|at|the|ground|(downward|is|positive), Wm-2, Reds
+GSW, gsw, net_shortwave_radiation_flux_at_ground, 0., 1000., net|shortwave|radiation|flux|at|the|ground|(downward|is|positive), Wm-2, Reds
+gsw, gsw, net_shortwave_radiation_flux_at_ground, 0., 1000., net|shortwave|radiation|flux|at|the|ground|(downward|is|positive), Wm-2, Reds
 h2o, h2o, water_mass_fraction, 0., 3.e-2, mass|fraction|of|water, 1, Blues
 LH2O, h2o, water_mass_fraction, 0., 3.e-2, mass|fraction|of|water, 1, Blues
@@ -146,4 +152,5 @@
 hfls, hfls, surface_upward_latent_heat_flux, -400., 400., upward|latnt|heat|flux|at|the|surface, Wm-2, seismic
 LH, hfls, surface_upward_latent_heat_flux, -400., 400., upward|latnt|heat|flux|at|the|surface, Wm-2, seismic
+lh, hfls, surface_upward_latent_heat_flux, -400., 400., upward|latnt|heat|flux|at|the|surface, Wm-2, seismic
 LFLAT, hfls, surface_upward_latent_heat_flux, -400., 400., upward|latnt|heat|flux|at|the|surface, Wm-2, seismic
 flat, hfls, surface_upward_latent_heat_flux, -400., 400., upward|latnt|heat|flux|at|the|surface, Wm-2, seismic
@@ -152,4 +159,5 @@
 sens, hfss, surface_upward_sensible_heat_flux, -150., 150., upward|sensible|heat|flux|at|the|surface, Wm-2, seismic
 HFX, hfss, surface_upward_sensible_heat_flux, -150., 150., upward|sensible|heat|flux|at|the|surface, Wm-2, seismic
+hfx, hfss, surface_upward_sensible_heat_flux, -150., 150., upward|sensible|heat|flux|at|the|surface, Wm-2, seismic
 hfso, hfso, downward_heat_flux_in_soil, -150., 150., Downward|soil|heat|flux, Wm-2, seismic
 GRDFLX, hfso, downward_heat_flux_in_soil, -150., 150., Downward|soil|heat|flux, Wm-2, seismic
@@ -288,6 +296,6 @@
 LTHETA, tah, potential_air_temperature, 195., 320., potential|air|temperature, K, YlOrRd
 tahs, tahs, potential_air_temperature, 195., 320., potential|air|temperature|at|2m, K, YlOrRd
+tas, tas, air_temperature, 240., 310., air|temperature|at|2m, K, YlOrRd
 TH2, tahs, potential_air_temperature, 195., 320., potential|air|temperature|at|2m, K, YlOrRd
-tas, tas, air_temperature, 240., 310., air|temperature|at|2m, K, YlOrRd
 T, tas, air_temperature, 240., 310., air|temperature|at|2m, K, YlOrRd
 T2, tas, air_temperature, 240., 310., air|temperature|at|2m, K, YlOrRd
@@ -303,4 +311,8 @@
 TKE, tke, turbulent_kinetic_energy, 0., 0.003, turbulent|kinetic|energy, m2/s2, Reds
 LTKE, tke, turbulent_kinetic_energy, 0., 0.003, turbulent|kinetic|energy, m2/s2, Reds
+tsk, tsk, skin_temperature, 240., 320., skin|temperature, K, YlOrRd
+tss, tss, soil_temperature, 240., 310., soil|surface|temperature, K, YlOrRd
+ts1, ts1, soil_temperature, 240., 310., soil|first|level|temperature, K, YlOrRd
+tslb1, ts1, soil_temperature, 240., 310., soil|first|level|temperature, K, YlOrRd
 time, time, time, 0., 1000., time, hours|since|1949/12/01|00:00:00, Reds
 time_counter, time, time, 0., 1000., time, hours|since|1949/12/01|00:00:00, Reds
@@ -350,9 +362,9 @@
 vitw, wap, upward_wind, -3.e-10, 3.e-10, upward|wind, mPa-1, seismic
 LVITW, wap, upward_wind, -3.e-10, 3.e-10, upward|wind, mPa-1, seismic
-wds, wds, air_direction,  0., 360., surface|horizontal|wind|direction, deg, Reds
-DD, wds, air_direction,  0., 360., surface|horizontal|wind|direction, deg, Reds
-TSwds, wds, air_direction,  0., 360., surface|horizontal|wind|direction, deg, Reds
-windir, wds, air_direction,  0., 360., surface|horizontal|wind|direction, deg, Reds
-wdir, wds, air_direction,  0., 360., surface|horizontal|wind|direction, deg, Reds
+wds, wds, air_direction,  0., 360., surface|horizontal|wind|direction, degree, Reds
+DD, wds, air_direction,  0., 360., surface|horizontal|wind|direction, degree, Reds
+TSwds, wds, air_direction,  0., 360., surface|horizontal|wind|direction, degree, Reds
+windir, wds, air_direction,  0., 360., surface|horizontal|wind|direction, degree, Reds
+wdir, wds, air_direction,  0., 360., surface|horizontal|wind|direction, degree, Reds
 wss, wss, air_velocity,  0., 30., surface|horizontal|wind|speed, ms-1, Reds
 FF, wss, air_velocity,  0., 30., surface|horizontal|wind|speed, ms-1, Reds