Index: trunk/tools/drawing.py
===================================================================
--- trunk/tools/drawing.py	(revision 619)
+++ trunk/tools/drawing.py	(revision 620)
@@ -1799,5 +1799,5 @@
       ncfilens= [filen] ',' separated list of netCDF files
       values= [dimvname];[valuesaxis];[dimtit];[leglabels];[vtit];[title];[timevals];[locleg];
-        [graphk];[collines];[period]
+        [graphk];[collines];[points];[period]
         [dimvname]: ',' list of names of the variables with he values of the common dimension
         [valuesaxis]: which axis will be used for the values ('x', or 'y')
@@ -1822,5 +1822,8 @@
           9: 'upper center', 10: 'center'
         [graphk]: kind of the graphic
-        [collines]: ',' list of colors for the lines or None for automatic
+        [collines]: ',' list of colors for the lines, None for automatic, single 
+          value all the same
+        [points]: ',' list of type of points for the lines, None for automatic, single
+          value all the same
         [period]: which period to plot
           '-1': all period
@@ -1838,5 +1841,6 @@
 
     expectargs = '[dimvname];[valuesaxis];[dimtit];[leglabels];[vtit];[title];'
-    expectargs = expectargs + '[timevals];[locleg];[graphk];[collines];[period]'
+    expectargs = expectargs + '[timevals];[locleg];[graphk];[collines];[points];'
+    expectargs = expectargs + '[period]'
     drw.check_arguments(fname,len(expectargs.split(';')),values,';',expectargs)
 
@@ -1852,5 +1856,6 @@
     graphk = values.split(';')[8]
     collines0 = values.split(';')[9]
-    period = values.split(';')[10]
+    points0 = values.split(';')[10]
+    period = values.split(';')[11]
 
     Nfiles = len(ncfiles)
@@ -1871,6 +1876,20 @@
     if collines0.find(',') != -1:
         collines = collines0.split(',')
-    else:
+    elif collines == 'None':
         collines = None
+    else:
+        collines = []
+        for ip in range(Nfiles):
+            collines.append(collines0)
+
+# Multiple point types?
+    if points0.find(',') != -1:
+        points = points0.split(',')
+    elif points0 == 'None':
+        points = None
+    else:
+        points = []
+        for ip in range(Nfiles):
+            points.append(points0)
 
 # Getting values
@@ -2006,5 +2025,5 @@
       drw.plot_lines_time(dimvalues, varvalues, valuesaxis, dimtit,                  \
         leglabels.split(','), vartit, varunits, timepos, timelabels, title, locleg,  \
-        graphk, collines)
+        graphk, collines, points)
     else:
       drw.plot_lines_time(dimvalues, varvalues, valuesaxis, dimtit,                  \
Index: trunk/tools/drawing_tools.py
===================================================================
--- trunk/tools/drawing_tools.py	(revision 619)
+++ trunk/tools/drawing_tools.py	(revision 620)
@@ -5205,5 +5205,5 @@
 
 def plot_lines_time(vardv, varvv, vaxis, dtit, linesn0, vtit, vunit, tpos, tlabs,    \
-  gtit, gloc, kfig, coll):
+  gtit, gloc, kfig, coll, ptl):
     """ Function to plot a collection of lines with a time axis
       vardv= list of set of dimension values
@@ -5223,4 +5223,9 @@
       kfig= kind of figure
       coll= ',' list of colors for the lines or None for automatic
+      coll= ',' list of colors for the lines, None for automatic, single
+          value all the same
+      ptl= ',' list of type of points for the lines, None for automatic, single
+          value all the same
+
       plot_lines([np.arange(10)], [np.sin(np.arange(10)*np.pi/2.5)], 'y', 'time (s)',      \
   ['2.5'], 'sin', '-', 'sinus frequency dependency', 'pdf')
@@ -5234,5 +5239,12 @@
 
 # Canging line kinds every 7 lines (end of standard colors)
-    linekinds=['.-','x-','o-']
+    linekinds = []
+    if ptl is None:
+        linekindsauto=['.-','x-','o-']
+        for ptype in range(4):
+            for ip in range(7):
+                linekinds.append(linekindsauto[ptype])
+    else:
+        linekinds = ptl
 
     Ntraj = len(vardv)
@@ -5256,7 +5268,7 @@
         for il in range(Ntraj):
             if coll is None:
-                plt.plot(varvv[il], vardv[il], linekinds[N7lines], label= linesn[il])
+                plt.plot(varvv[il], vardv[il], linekinds[il], label= linesn[il])
             else:
-                plt.plot(varvv[il], vardv[il], linekinds[N7lines], label= linesn[il],\
+                plt.plot(varvv[il], vardv[il], linekinds[il], label= linesn[il],\
                   color=coll[il])
 
@@ -5270,6 +5282,4 @@
             if mindv < xtrmdv[0]: xtrmdv[0] = mindv
             if maxdv > xtrmdv[1]: xtrmdv[1] = maxdv
-
-            if il == 6: N7lines = N7lines + 1
 
         plt.xlabel(vtit + ' (' + vunit + ')')
@@ -5284,7 +5294,7 @@
         for il in range(Ntraj):
             if coll is None:
-                plt.plot(vardv[il], varvv[il], linekinds[N7lines], label= linesn[il])
+                plt.plot(vardv[il], varvv[il], linekinds[il], label= linesn[il])
             else:
-                plt.plot(vardv[il], varvv[il], linekinds[N7lines], label= linesn[il],\
+                plt.plot(vardv[il], varvv[il], linekinds[il], label= linesn[il],\
                   color=coll[il])
 
@@ -5298,6 +5308,4 @@
             if mindv < xtrmdv[0]: xtrmdv[0] = mindv
             if maxdv > xtrmdv[1]: xtrmdv[1] = maxdv
-
-            if il == 6: N7lines = N7lines + 1
 
         plt.xlabel(dtit)