Index: trunk/tools/drawing.py
===================================================================
--- trunk/tools/drawing.py	(revision 664)
+++ trunk/tools/drawing.py	(revision 665)
@@ -25,4 +25,5 @@
 ## e.g. # drawing.py -o draw_points -S 'tslist.dat,#,3,2,1:SuperStorm|sfc|stations:cyl,i:labelled,8,black:auto:None:0:png:stations_loc' -f $HOME'/etudes/domains/WRFdynamicoSENS_SuperStorm/geo_em_west_east_B25-E180-I1_south_north_B160-E262-I1.nc,XLONG_M,XLAT_M,HGT_M,Time|0,height,0.,1500.,terrain,m'
 ## e.g. # drawing.py -o draw_ptZvals -f geo_v2_2012102123_RR1.nc -S 'pracc:lon,lat:o:80:2,42,7,47,:values!of!values:Blues:cyl,l:pdf' -v pr
+## e.g. # drawing.py -f carteveg5km.nc -o draw_points_lonlat -S 'longitude:latitude:pdf:points!veget|type:green:.:None:0:legend'
 
 main = 'drawing.py'
@@ -34,6 +35,6 @@
 namegraphics = ['create_movie', 'draw_2D_shad', 'draw_2D_shad_time',                 \
   'draw_2D_shad_cont', 'draw_2D_shad_cont_time', 'draw_2D_shad_line',                \
-  'draw_2D_shad_line_time', 'draw_barbs', 'draw_points', 'draw_ptZvals',             \
-   'draw_timeSeries',                                                                \
+  'draw_2D_shad_line_time', 'draw_barbs', 'draw_points', 'draw_points_lonlat',       \
+  'draw_ptZvals', 'draw_timeSeries',                                                 \
   'draw_topo_geogrid',                                                               \
   'draw_topo_geogrid_boxes', 'draw_trajectories', 'draw_vals_trajectories',          \
@@ -2436,4 +2437,75 @@
     return
 
+def draw_points_lonlat(filen, values):
+    """ Function to plot a series of lon/lat points
+     filen= name of the file
+     values= [lonvarname]:[latvarname]:[gkind]:[gtit]:[ptcolor]:[pttype]:[labels]:[locleg]:[figureK]
+       [lonvarname]: name of the variable longitude
+       [latvarname]: name of the variable latitude
+       [gkind]: kind of graphical output
+       [gtit]: graphic title '!' for spaces
+       [ptcolor]: color of the points ('auto', for "red")
+       [pttype]: type of point
+       [labels]: ',' list of labels to use
+       [locleg]: location of the legend (0, automatic)
+         1: 'upper right', 2: 'upper left', 3: 'lower left', 4: 'lower right',
+         5: 'right', 6: 'center left', 7: 'center right', 8: 'lower center',
+         9: 'upper center', 10: 'center'
+       [figureK]= kind of figure
+         'legend': only points in the map with the legend with the names
+         'labelled',[txtsize],[txtcol]: points with the names and size, color of text
+    """
+    fname = 'draw_points_lonlat'
+
+    if values == 'h':
+        print fname + '_____________________________________________________________'
+        print draw_points_lonlat.__doc__
+        quit()
+
+    expectargs = '[lonvarname]:[latvarname]:[gkind]:[gtit]:[ptcolor]:[pttype]:' +    \
+      '[labels]:[locleg]:[figureK]'
+ 
+    drw.check_arguments(fname,len(expectargs.split(':')),values,':',                 \
+      expectargs.split(','))
+
+    lonname = values.split(':')[0]
+    latname = values.split(':')[1]
+    kindfigure = values.split(':')[2]
+    gtit = values.split(':')[3].replace('!',' ')
+    pointcolor = values.split(':')[4]
+    pointtype = values.split(':')[5]
+    labelsv = values.split(':')[6]
+    loclegend = values.split(':')[7]
+    figureK = values.split(':')[8]
+
+    fname = 'points_lonlat'
+
+    onc = NetCDFFile(filen, 'r')
+    if not onc.variables.has_key(lonname):
+        print errmsg
+        print fname + ": file '" + filen + "' does not have longitudes '" + lonname +\
+          "' !!"
+        quit(-1)
+    if not onc.variables.has_key(lonname):
+        print errmsg
+        print fname + ": file '" + filen + "' does not have longitudes '" + lonname +\
+          "' !!"
+        quit(-1)
+    
+    olon = onc.variables[lonname]
+    olat = onc.variables[latname]
+
+    if labelsv == 'None':
+        labels = None
+    else:
+        labels = labelsv.split(',')
+
+    drw.plot_list_points(olon[:], olat[:], gtit, figureK, pointcolor, pointtype,     \
+      labels, loclegend, kindfigure, fname)
+
+    onc.close()
+
+    return
+
 def draw_timeSeries(filen, values, variables):
     """ Function to draw a time-series
@@ -3056,4 +3128,6 @@
 elif oper == 'draw_points':
     draw_points(opts.ncfile, opts.values)
+elif oper == 'draw_points_lonlat':
+    draw_points_lonlat(opts.ncfile, opts.values)
 elif oper == 'draw_ptZvals':
     draw_ptZvals(opts.ncfile, opts.values, opts.varname)
Index: trunk/tools/drawing_tools.py
===================================================================
--- trunk/tools/drawing_tools.py	(revision 664)
+++ trunk/tools/drawing_tools.py	(revision 665)
@@ -2763,4 +2763,55 @@
     return
 
+def plot_list_points(xval, yval, vtit, figk, color, ptk, labels, lloc, kfig, figname):
+    """ plotting points
+      [x/yval]: x,y values to plot
+      vtit= title of the graph ('|' for spaces)
+      figK= kind of figure
+        'legend': only points in the map with the legend with the names
+        'labelled',[txtsize],[txtcol]: points with the names and size, color of text
+      color= color for the points/labels ('auto', for "red")
+      ptk= kind of point
+      labels= list of labels for the points (None, no labels)
+      lloc = localisation of the legend
+      kfig= kind of figure (jpg, pdf, png)
+      figname= name of the figure
+
+    """
+    fname = 'plot_points'
+# Canging line kinds every 7 pts (end of standard colors)
+    ptkinds=['.','x','o','*','+','8','>','D','h','p','s']
+
+    if color == 'auto':
+        ptcol = "red"
+    else:
+        ptcol = color
+
+    plt.rc('text', usetex=True)
+
+    if labels is not None:
+        for iv in range(len(xval)):
+#            print iv,xval[iv],yval[iv],labels[iv],ptkinds[N7pts]
+            plt.plot(xval[iv],yval[iv], ptk,label=labels[iv])
+
+        if figk[0:8] == 'labelled':
+            txtsize=int(figk.split(',')[1])
+            txtcol=figk.split(',')[2]
+            for iv in range(len(xval)):
+                plt.annotate(labels[iv], xy=(xval[iv],yval[iv]), xycoords='data',    \
+                  fontsize=txtsize, color=txtcol)
+        elif figk == 'legend':
+            plt.legend(loc=lloc)
+
+    else: 
+        plt.plot(xval, yval, ptk, color=ptcol)
+
+    graphtit = vtit.replace('_','\_').replace('&','\&')
+
+    plt.title(graphtit.replace('|', ' '))
+    
+    output_kind(kfig, figname, True)
+
+    return
+
 def plot_2Dfield(varv,dimn,colorbar,vn,vx,unit,olon,olat,ifile,vtit,zvalue,time,tk,  \
    tkt,tobj,tvals,tind,kfig,mapv,reva):
@@ -3029,5 +3080,5 @@
 def plot_Trajectories(lonval, latval, linesn, olon, olat, lonlatLims, gtit, kfig,    \
   mapv, obsname):
-    """ plotting points
+    """ plotting Trajectories
       [lon/latval]= lon,lat values to plot (as list of vectors)
       linesn: name of the lines